'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.init = init;

function _interopExportWildcard(obj, defaults) { var newObj = defaults({}, obj); delete newObj['default']; return newObj; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _models = require('./models');

var _models2 = _interopRequireDefault(_models);

var _resourceRouter = require('./resource-router');

var _resourceRouter2 = _interopRequireDefault(_resourceRouter);

var initialized;
var configured;
var initPromise = _bluebird2['default'].fromNode(function (cb) {
  initialized = cb;
});

exports['default'] = function (name) {
  return initPromise.then(function (collections) {
    if (!name) return collections;
    (0, _assert2['default'])(collections[name], 'No collection with name "' + name + '" exists');
    return collections[name];
  });
};

function init(config) {
  (0, _assert2['default'])(!configured, 'You can only initialize waterline-models once');

  configured = true;

  // Defaults
  config = Object.assign({
    dir: _path2['default'].join(process.cwd(), 'models'),
    defaults: {},
    adapters: {},
    connections: {}
  }, config);

  // Passing
  (0, _models2['default'])(config).nodeify(initialized);

  return (0, _resourceRouter2['default'])(config);
}

var _methods = require('./methods');

_defaults(exports, _interopExportWildcard(_methods, _defaults));