'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.list = list;
exports.create = create;
exports.get = get;
exports.update = update;
exports.destroy = destroy;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _i = require('i');

var _i2 = _interopRequireDefault(_i);

var _ = require('./');

var _2 = _interopRequireDefault(_);

var _methods = require('./methods');

var methods = _interopRequireWildcard(_methods);

var inflect = new _i2['default']();
var singularize = inflect.singularize.bind(inflect);

exports['default'] = function (config) {

  var router = _express2['default'].Router();

  router.use('/:resource', getResource);

  router.route('/:resource').get(list).post(create);

  router.route('/:resource/:id').get(get).put(update)['delete'](destroy);

  return router;

  /** Inject model **/
  function getResource(req, res, next) {
    (0, _2['default'])(singularize(req.params.resource)).then(function (model) {
      req.model = model;
    }).then(next)['catch'](next);
  }
};

/*** ---CRUD Methods--- ***/

/** Query resource list **/

function list(req, res, next) {
  methods.list(req.model, req).then(res.send.bind(res))['catch'](next);
}

/** Create new resource **/

function create(req, res, next) {
  methods.create(req.model, req).then(res.send.bind(res))['catch'](next);
}

/** Return a single resource by ID **/

function get(req, res, next) {
  methods.get(req.model, req).then(res.send.bind(res))['catch'](next);
}

/** Update a single resource by ID **/

function update(req, res, next) {
  methods.update(req.model, req).then(res.send.bind(res))['catch'](next);
}

/** Destroy a single resource by ID **/

function destroy(req, res, next) {
  methods.destroy(req.model, req).then(res.send.bind(res))['catch'](next);
}